#define BLYNK_TEMPLATE_ID "id"
#define BLYNK_TEMPLATE_NAME "Quickstart Template"
#define BLYNK_AUTH_TOKEN "auth"

#include <Arduino.h>
#include <WiFi.h>
#include <BlynkSimpleEsp32.h>
#include <esp32Servo.h>

char ssid[] = "ss"; // Replace with your network SSID
char pass[] = "pw"; // Replace with your network password

// Motor Driver 1
#define IN1 14
#define IN2 27
#define IN3 26
#define IN4 33

// Motor Driver 2
#define IN5 17
#define IN6 16
#define IN7 4
#define IN8 0

#define ENA 12
#define ENB 32
#define ENC 5
#define END 2
Servo servo;  // create servo object
int servoPin = 13;  // connect servo signal wire to digital pin 13


void setup() {
  // put your setup code here, to run once:
  pinMode(2, OUTPUT); // set GPIO2 as output
  servo.attach(servoPin);  // attaches the servo on pin 9 to the servo object
  Blynk.begin(BLYNK_AUTH_TOKEN, ssid, pass); // Connect to Blynk

  while (Blynk.connect() == false) {
    // Wait until connected
  }


  // Set the motor control pins as output
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  pinMode(IN5, OUTPUT);
  pinMode(IN6, OUTPUT);
  pinMode(IN7, OUTPUT);
  pinMode(IN8, OUTPUT);
  pinMode(ENA, OUTPUT);
  pinMode(ENB, OUTPUT);
  pinMode(ENC, OUTPUT);
  pinMode(END, OUTPUT);

  // Set the enable pins as output and set them to LOW
}

BLYNK_WRITE(V1) // Blynk app writes to virtual pin V1
{
  int buttonState = param.asInt(); // assigning incoming value from pin V1 to a variable
  if (buttonState == 1) { // if button is pressed
    // Code to move forward
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    digitalWrite(IN5, HIGH);
    digitalWrite(IN6, LOW);
    digitalWrite(IN7, HIGH);
    digitalWrite(IN8, LOW);
    digitalWrite(ENA, HIGH);
    digitalWrite(ENB, HIGH);
    digitalWrite(ENC, HIGH);
    digitalWrite(END, HIGH);
  } else if (buttonState == 0) { // if button is released
    // Code to stop
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, LOW);
    digitalWrite(IN5, LOW);
    digitalWrite(IN6, LOW);
    digitalWrite(IN7, LOW);
    digitalWrite(IN8, LOW);
  }
}

BLYNK_WRITE(V2) // Blynk app writes to virtual pin V2 for backward
{
  int buttonState = param.asInt(); // assigning incoming value from pin V2 to a variable
  if (buttonState == 1) { // if button is pressed
    // Code to move backward
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, HIGH);
    digitalWrite(IN5, LOW);
    digitalWrite(IN6, HIGH);
    digitalWrite(IN7, LOW);
    digitalWrite(IN8, HIGH);
    digitalWrite(ENA, HIGH);
    digitalWrite(ENB, HIGH);
    digitalWrite(ENC, HIGH);
    digitalWrite(END, HIGH);
  } else if (buttonState == 0) { // if button is released
    // Code to stop
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, LOW);
    digitalWrite(IN5, LOW);
    digitalWrite(IN6, LOW);
    digitalWrite(IN7, LOW);
    digitalWrite(IN8, LOW);
  }
}

BLYNK_WRITE(V3) // Blynk app writes to virtual pin V3 for left
{
  int buttonState = param.asInt(); // assigning incoming value from pin V3 to a variable
  if (buttonState == 1) { // if button is pressed
    // Code to move left
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    digitalWrite(IN5, HIGH);
    digitalWrite(IN6, LOW);
    digitalWrite(IN7, LOW);
    digitalWrite(IN8, HIGH);
    digitalWrite(ENA, HIGH);
    digitalWrite(ENB, HIGH);
    digitalWrite(ENC, HIGH);
    digitalWrite(END, HIGH);
  } else if (buttonState == 0) { // if button is released
    // Code to stop
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, LOW);
    digitalWrite(IN5, LOW);
    digitalWrite(IN6, LOW);
    digitalWrite(IN7, LOW);
    digitalWrite(IN8, LOW);
  }
}

BLYNK_WRITE(V4) // Blynk app writes to virtual pin V4 for right
{
  int buttonState = param.asInt(); // assigning incoming value from pin V4 to a variable
  if (buttonState == 1) { // if button is pressed
    // Code to move right
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, HIGH);
    digitalWrite(IN5, LOW);
    digitalWrite(IN6, HIGH);
    digitalWrite(IN7, HIGH);
    digitalWrite(IN8, LOW);
    digitalWrite(ENA, HIGH);
    digitalWrite(ENB, HIGH);
    digitalWrite(ENC, HIGH);
    digitalWrite(END, HIGH);
  } else if (buttonState == 0) { // if button is released
    // Code to stop
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, LOW);
    digitalWrite(IN5, LOW);
    digitalWrite(IN6, LOW);
    digitalWrite(IN7, LOW);
    digitalWrite(IN8, LOW);
  }
}

int currentAngle = 0;  // global variable to keep track of the current angle

BLYNK_WRITE(V5) // Blynk app writes to virtual pin V5 for servo control
{
  int buttonState = param.asInt(); // assigning incoming value from pin V5 to a variable
  if (buttonState == 1) { // if button is pressed
    currentAngle += 90;  // increase the current angle by 90 degrees
    if (currentAngle > 360) {  // if the current angle exceeds 360 degrees
      currentAngle = 0;  // reset the current angle to 0 degrees
    }
    servo.write(currentAngle);  // turn servo to the current angle
  }
}

BLYNK_WRITE(V0) // Blynk app writes to virtual pin V2
{
  int buttonState = param.asInt(); // assigning incoming value from pin V2 to a variable
  if (buttonState == 1) { // if button is pressed
    // Turn on the built-in LED
    digitalWrite(2, HIGH); // the built-in LED is on when the pin is LOW
  } else if (buttonState == 0) { // if button is released
    // Turn off the built-in LED
    digitalWrite(2, LOW); // the built-in LED is off when the pin is HIGH
  }
}
void loop() {
  // put your main code here, to run repeatedly:
  Blynk.run(); // This line is needed to run Blynk
}
